'From Jasmine-rc1 of 7 October 2004 [latest update: #200] on 9 January 2005 at 12:02:03 pm'!
"Change Set:		Croquet-Croquet
Date:			09 January 2005
Author:			Dave Faught

The game of Croquet for the Croquet environment.
Someone Had To Do It."!

Smalltalk renameClassNamed: #TSHTDI as: #SHTDI!
TeapotMorph subclass: #SHTDI
	instanceVariableNames: 'cworld sceneObjects floor world space contacts prevTime rnd mallet malletJoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!

!SHTDI commentStamp: 'daf 12/15/2004 20:21' prior: 0!
Someone Had To Do It.!

Object subclass: #SHTDIDistro
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE-Croquet'!

!SHTDIDistro commentStamp: 'daf 12/25/2004 20:50' prior: 0!
Build a sar file for SHTDI!

TCube subclass: #TCubeComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE-Croquet'!

!TCubeComponent commentStamp: 'daf 12/24/2004 10:05' prior: 0!
This is meant to be a child of a TGroupODE.!

TCube subclass: #TCubeODE
	instanceVariableNames: 'body pickDelta selectedPoint myPointer '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
TCylinder subclass: #TCylinderComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE-Croquet'!

!TCylinderComponent commentStamp: 'daf 12/20/2004 20:11' prior: 0!
This is meant to be a child of a TGroupODE.!

TCylinder subclass: #TCylinderODE
	instanceVariableNames: 'body pickDelta selectedPoint myPointer '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
TGroup subclass: #TGroupODE
	instanceVariableNames: 'body myPointer selectedPoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!

!TGroupODE commentStamp: 'daf 12/24/2004 10:07' prior: 0!
This frame holds the ODE physics body, along with picking and stepping methods for a composite object.!

TMesh subclass: #TMeshComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ODE-Croquet'!

!TMeshComponent commentStamp: 'daf 12/24/2004 10:05' prior: 0!
This is meant to be a child of a TGroupODE.!

TMesh subclass: #TMeshODE
	instanceVariableNames: 'body myPointer selectedPoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
TSphere subclass: #TSphereODE
	instanceVariableNames: 'body pickDelta selectedPoint myPointer '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!

!ODEBody methodsFor: 'accessing' stamp: 'daf 12/18/2004 14:32'!
rotationAroundX: degree
	rotation _ Driver dRFromAxisAndAngle: 1 with: 0 with: 0 with: degree degreesToRadians.
	self setStatus! !


!SHTDI methodsFor: 'initialization' stamp: 'daf 12/15/2004 20:20'!
initODE

	prevTime _ Time millisecondClockValue.

	world _ ODEWorld new.
	space _ ODESpace new.
	
	world add: (contacts _ ODEContactGroup new).
	world gravity: #(0 -9.81 0 ).
	sceneObjects _ Dictionary new.

	rnd _ Random new.
	
! !

!SHTDI methodsFor: 'initialization' stamp: 'daf 12/15/2004 20:29'!
initWorld: ground

	| |

"	world add: (body _ ODEBody new).
	body position: (ground globalPosition)."
"	space add: (ODEBox new extent: (ground extent))."
	space add: (ODEPlane new planeA: 1 b:0 c:0 d:-40).	
	space add: (ODEPlane new planeA: 0 b:0 c:1 d:-40).	
	space add: (ODEPlane new planeA:-1 b:0 c:0 d:-40).	
	space add: (ODEPlane new planeA: 0 b:0 c:-1 d:-40).	

	space add: (ODEPlane new planeA: 0 b:1 c:0 d: (ground globalPosition y + (ground extent y / 2))).! !

!SHTDI methodsFor: 'initialization' stamp: 'daf 12/15/2004 20:27'!
initializeDefaultSpace
	| |
	cworld _ TSpace new.
	"Add a light to the world"
	self makeLight: cworld.

	self addInstruction.
	floor _ self makeFloor: cworld fileName: 'lawn.bmp'.
	floor translationX: 0 y: -3 z: 0.
	self initODE.
	self initWorld: floor.
	^ cworld! !

!SHTDI methodsFor: 'events' stamp: 'daf 1/9/2005 09:41'!
keyStroke: anEvent
	| kv kc |
	kc _ anEvent keyCharacter "asLowercase".
	kv _ anEvent keyValue.

"Transcript show: anEvent."

"b"	kc = $b ifTrue:[^self addBall].
"B"	kc = $B ifTrue:[^self addBall2].
"m"	kc = $m ifTrue:[^self addMallet].
"M"	kc = $M ifTrue:[^self addMallet2].
"p" kc = $p ifTrue:[^self addCylinder].
"t" kc = $t ifTrue:[^self wind].
"w"	kc = $w ifTrue:[^self addWicket].

	(#(28 29 30 31) includes: kv) ifTrue: [^self].
"	kv = 32 ifTrue:[^self transferCam: chassis]."
	super keyStroke: anEvent.
! !

!SHTDI methodsFor: 'events' stamp: 'daf 1/9/2005 09:32'!
stepAt: currentTime

	| dur |
	super step.
	space ifNil: [^self].

	world connect.
	space connect.
					
	dur _ ((currentTime asFloat) - (prevTime asFloat)) / 1000.
	prevTime _ currentTime.
	
	sceneObjects do:[:id|
		| each body |
		each _ id at:1. 
		body _ id at:2.
		each isStepping not ifTrue:[
			each localTransform: body transform transposed.
			]
		ifFalse:[ 
			body linearVel:  each globalPosition - (body position) * 10.	
			body position: each globalPosition.
			body quaternion: (each quaternion)
			].
		].
		space
			collideDo: [:geom1 :geom2 |  
					contacts	
						addContact: geom1
						with: geom2
						bounce: 0.03
						bounceVel: 0.2
						softCFM: 0.000000001.].
		world quickStep: dur. "0.3 . "

		contacts empty.

		
	
! !

!SHTDI methodsFor: 'events' stamp: 'daf 12/15/2004 20:20'!
wantsSteps


    ^true! !

!SHTDI methodsFor: 'creation' stamp: 'daf 1/9/2005 09:18'!
addBall
	| myTexture ball1 body geom |

	myTexture _ TTexture
				new initializeWithFileName:  'ballHog.gif'.
	"myTexture _ self makeCoolTexture."

	ball1 _ TSphereODE new.
	ball1 segments: 20.
	ball1 radius: 0.6.
	ball1 texture: myTexture.
	ball1
		translationX: 0
		y: 15
		z: 0.
	cworld addChild: ball1.
	world add: (body _ ODEBody new).
	body position: ball1 globalPosition.
	body massSphere: 1.
	space add: (geom _ ODESphere new radius: ball1 radius).
	geom body: body.
	ball1 body: body.
	sceneObjects at: body id put: {ball1. body. geom}
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 1/9/2005 09:01'!
addBall2
	"from an email post by Bob Arning"
	| myTexture ball1 body geom |

	myTexture _ self makeCoolTexture.

	ball1 _ TSphereODE new.
	ball1 segments: 20.
	ball1 radius: 0.6.
	ball1 texture: myTexture.
	ball1
		translationX: 0
		y: 15
		z: 0.
	cworld addChild: ball1.
	world add: (body _ ODEBody new).
	body position: ball1 globalPosition.
	body massSphere: 1.
	space add: (geom _ ODESphere new radius: ball1 radius).
	geom body: body.
	ball1 body: body.
	sceneObjects at: body id put: {ball1. body. geom}
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/21/2004 20:20'!
addCylinder
	| body geom cyl |
	txtr _ self makeCoolTexture.
	cyl _ TCylinderODE new.
	cyl
		translationX: 0
		y: 15
		z: 0.
	cyl rotationAroundX: -90.
	cyl baseRadius: 0.2.
	cyl topRadius: cyl baseRadius.
	cyl height: 3.
	cyl slices: 16.
	cyl texture: txtr.
	world add: (body _ ODEBody new).
	body position: cyl globalPosition.
	body quaternion: (cyl quaternion).
	body massBox: 200.0 extent: cyl extent.
	space add: (geom _ ODEBox new extent: cyl extent).
	geom body: body.
	cyl body: body.
	sceneObjects at: body id put: {cyl. body. geom}.
	cworld addChild: cyl.
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/21/2004 20:16'!
addInstruction
	| win extent tm teaWorld page holder |
	extent _ 400 @ 250.
	tm _ TMorphic new initializeOpaque: true extent: extent.
	teaWorld _ TMorphMonitor new initializeWithWorld: nil extent: extent.
	teaWorld eventsTo: tm.
	world _ teaWorld world.
	holder _ StringHolder new contents: self instructionText.
	page _ PluggableTextMorph on: holder text: #contents accept: #acceptContents:.
	page color: Color white.
	world addMorph: page.
	page bounds: world bounds.
	win _ TWindow new.
	win translationX: 5 y: 2 z: 30.
	win rotationAroundY: -90.
	win contents: tm.
	cworld addChild: win! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/26/2004 21:22'!
addMallet

	| body geom handle url urlHand hand body2 geom2 hinge pos |

	txtr _ TTexture new initializeWithFileName:  'mallet.gif'.
	url _ 'http://www.reed.com/TeaLand/widgets/mallet.tea'.
	urlHand _ 'http://www.reed.com/TeaLand/widgets/handClosed.tea'.

	mallet _ TGroupODE new.
	mallet translationX: 0 y: 1  z: 0.

	handle _ (CroquetData loadURL: url reuseExisting: false).
	handle ifNil:[
		handle _ Cursor wait showWhile:[self makePopoutObjectFrom: txtr].
		handle translationX: -1.7 y: 2.7  z: 0. "why are these offsets needed"
		TExporter export: handle asBinary:url].
	handle solid: true.
	mallet addChild: handle.

	world add: (body _ ODEBody new).
	body position: (mallet globalPosition).
	body massBox: 50.0 extent: mallet extent.
	space add: (geom _ ODEBox new extent: mallet extent).
	geom body:  body.
	mallet body: body.
	sceneObjects at: body id  put: {mallet. body. geom.}.

"for some real fun with a hinged mallet, uncomment the code from here"
"	hand _ TMeshODE new fromTMesh: (CroquetData loadURL: urlHand reuseExisting: false).
	hand scale: 2.0.
	hand translationX: 1.0 y: mallet extent y / 2.0 + 2.0 z: 0.
	world add: (body2 _ ODEBody new).
	body2 position: (hand globalPosition).
	body2 massBox: 50.0 extent: hand extent.
	space add: (geom2 _ ODEBox new extent: hand extent).
	geom2 body:  body2.
	hand body: body2.
	sceneObjects at: body2 id  put: {hand. body2. geom2.}.

	hinge _ ODEHinge new.
	hinge attach: body with: body2.
	pos _ mallet globalPosition.
	hinge anchor: {pos x + 1.0. pos y + mallet extent y / 2.0 + 2.0. pos z}.
	hinge axis: #(0 0 1).
	malletJoint _ hinge.

	cworld addChild: hand."
"to here"
	cworld addChild: mallet.
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 1/9/2005 09:03'!
addMallet2

	| body geom handle head |

	txtr _ TTexture
				new initializeWithFileName:  'Wood Plank Weather2.bmp'.
	"txtr	scale: 13."

	mallet _ TGroupODE new.
	mallet translationX: 0 y: 3  z: 0.

	handle _ TCylinderComponent new.
	handle baseRadius: 0.25.
	handle topRadius: handle baseRadius.
	handle height: 5.0.
	handle translationX: 0 y:-2.5  z: 0.
"	handle rotationAroundX: -90."
	handle texture: txtr.
	handle solid: true.
	mallet addChild: handle.

	head _ TCylinderComponent new.
	head baseRadius: 0.4.
	head topRadius: head baseRadius.
	head height: 2.0.
	head translationX: 0 y: -2.5  z: 1.
	head rotationAroundX: -90.
	head texture: txtr.
	head solid: true.
	mallet addChild: head.

	world add: (body _ ODEBody new).
	body position: (mallet globalPosition).
	body massBox: 100.0 extent: mallet extent.
	space add: (geom _ ODEBox new extent: mallet extent).
	geom body:  body.
	mallet body: body.
	sceneObjects at: body id  put: {mallet. body. geom.}.

"	susp _ ODEHinge new anchor: (mallet globalPosition).
	susp axis: #(0 0 1).
	susp attach: body with: body2.
	malletJoint _ susp."

	cworld addChild: mallet.
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/21/2004 20:03'!
addWicket
	| body geom wicket side1 side2 top |
	txtr _ TTexture
				new initializeWithFileName:  'Metal Generic.bmp'.

	wicket _ TGroupODE new.
	wicket translationX: 0 y: 5  z: 0.

	side1 _ TCubeComponent new.
	side1 extentX: 0.2 y: 3.0 z: 0.2.
	side1 translationX: 0 y: -1.5  z: 1.
"	side1 rotationAroundX: -90."
	side1 texture: txtr.
	side1 solid: true.
	wicket addChild: side1.

	side2 _ TCubeComponent new.
	side2 extentX: 0.2 y: 3.0 z: 0.2.
	side2 translationX: 0 y: -1.5  z: -1.
"	side2 rotationAroundX: -90."
	side2 texture: txtr.
	side2 solid: true.
	wicket addChild: side2.

	top _ TCubeComponent new.
	top extentX: 0.2 y: 0.2 z: 2.0.
	top translationX: 0 y: -0  z: 0.
"	top rotationAroundX: -90."
	top texture: txtr.
	top solid: true.
	wicket addChild: top.

	world add: (body _ ODEBody new).
	body position: wicket globalPosition.
	body massBox: 5.0 extent: wicket extent.
	"body massSphere: 5.0."
	space add: (geom _ ODEBox new extent: wicket extent).
	geom body: body.
	wicket body: body.
	sceneObjects at: body id put: {wicket. body. geom}.
	cworld addChild: wicket.! !

!SHTDI methodsFor: 'creation' stamp: 'daf 1/9/2005 09:42'!
instructionText
	"(self basicNew instructionText asParagraph compositionRectangle: (0@0 
	extent: 400@250))displayAt: 0@0"
	| html |
	html _ '
<h1><font size=7 color="#880000">How to play ODE Croquet</red></h1>
<ul>
<li>b or B : Add a ball.</li>
<li>m or M : Add a mallet.</li>
<li>p : Add a post</li>
<li>t : Blow by wind.</li>
<li>w : Add a wicket.</li>
</ul>
You can move an object around by dragging it with the avatar pointer.<br>
Holding down the Shift key while dragging moves in and out.
'.
	^ (HtmlParser parse: html readStream) formattedText! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/21/2004 20:19'!
makeCoolTexture
	"from an email post by Bob Arning"
	| depth form dim myTexture bands gap c y1 |

	depth _ 32.
	dim _ 256.
	bands _ 24.
	gap _ dim // bands.
	form _ Form extent: dim@dim depth: depth.
	c _ Color random.
	y1 _ dim - gap // 2. 
	0 to: bands // 2 do: [ :i |
		10 atRandom > 6 ifTrue: [c _ Color random].
		form getCanvas
			fillRectangle: (0@(y1+(i*gap)) extent: dim@gap) 
			color: c.
		form getCanvas
			fillRectangle: (0@(y1-(i*gap)) extent: dim@gap) 
			color: c.
	].
	0 to: bands // 2 do: [ :i |
		form getCanvas
			fillRectangle: (0@(y1+(i*gap)) extent: dim@1) 
			color: Color darkGray.
		form getCanvas
			fillRectangle: (0@(y1-(i*gap)) extent: dim@1) 
			color: Color darkGray.
	].
	"(SketchMorph withForm: form) openInWorld."
	form _ form asTexture.
	form
		wrap: true;
		interpolate: true;
		envMode: 0.

	myTexture _ TTexture new 
		initializeWithForm: form 
		mipmap: true 
		shrinkFit: false.
	^ myTexture
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/24/2004 10:15'!
makePopoutObjectFrom: aTTexture
	| bbForm mat b3dMesh mesh scale tfm aForm rot |
	"Convert the form"
	aForm := aTTexture targetForm.
	bbForm := Form extent: aForm extent asSmallerPowerOfTwo depth: 32.
	aForm displayScaledOn: bbForm in: (bbForm boundingBox insetBy: 1).
	"Smear the borders of the texture a bit to prevent problems in texture mapping"
	bbForm smearFill: 10. "pixels - less is faster but more is safer"

	"The material"
	mat _ TMaterial meta new.
	mat meta ambientColor: #(1 1 1 1) asFloatArray.
	mat meta diffuseColor: #(1 1 1 1) asFloatArray.

	mat meta texture: aTTexture.
	mat meta textureMode: GLModulate.

	"The b3d mesh"
	b3dMesh := self makePopoutMeshFrom: aForm.
	scale := 0.01.
	rot := 0.
	tfm := (B3DRotation axis: 1@0@0 angle: 180) asMatrix4x4.
	tfm := tfm composeWith: (B3DRotation axis: 0@1@0 angle: rot) asMatrix4x4.
	tfm := tfm composeWith: (B3DMatrix4x4 withScale: scale@scale@scale).
	tfm := tfm composeWith: (B3DMatrix4x4 withOffset: (aForm width * -0.5) @ (aForm height * -0.5) @ 0).
	b3dMesh transformBy: tfm.

	"The TMesh"
	mesh := TMeshComponent meta new.
	mesh meta initializeWithVertices: b3dMesh vertices 
		alias: nil 
		norms: b3dMesh vertexNormals
		textureUV: b3dMesh texCoords
		faceGroups: {1. b3dMesh zeroBasedFaceGroup}
		material: mat.
	mesh meta initBounds.
	^ mesh
! !

!SHTDI methodsFor: 'creation' stamp: 'daf 12/15/2004 20:20'!
wind
	sceneObjects
		do: [:id | 
			| each body | 
			each _ id at: 1.
			body _ id at: 2.
			each parent = cworld
				ifTrue: [body linearVel: body linearVel + self activeCamera lookAt]
				ifFalse: [body position: each globalPosition]]! !


!SHTDI class methodsFor: 'as yet unclassified' stamp: 'daf 12/19/2004 10:47'!
descriptionForPartsBin
	^ self partName:	'SHTDI ODE Tea Test '
		categories:		#('Croquet')
		documentation:	'ODE falling box demo'
		sampleImageForm: (Form extent: 32@32 depth: 32 bits: (Bitmap decompressFromByteArray: (Base64MimeConverter mimeDecode: '5ABC/xQUFB//ExMU/w4NFP+agRT/KicU/xISFf8RERH/AgICCv8AAAAb/wICAv8DAwP/AQEB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' as: String) asByteArray)).

! !

!SHTDI class methodsFor: 'as yet unclassified' stamp: 'daf 12/15/2004 20:20'!
includeInNewMorphMenu

	^true! !


!SHTDIDistro methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 20:50'!
seeClassSide! !


!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 20:54'!
changeSetBaseFileNames
	"SHTDIDistro changeSetBaseFileNames"
	^self changeSetFullFileNames collect: [ :ea | FileDirectory localNameFor: ea ]! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 20:54'!
changeSetDirectory
	^FileDirectory default! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 20:54'!
changeSetFullFileNames
	"SHTDIDistro changeSetFullFileNames"
	| dir |
	dir _ self changeSetDirectory.
	^self changeSets collect: [ :s | 
		dir fullNameFor: (dir lastNameFor: s extension: 'cs') ]! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 20:57'!
changeSets
	^{
'Croquet-Croquet'.
}
! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 22:08'!
makeSAR
	"
	SHTDIDistro makeSAR
	"
	| sar result sarName |
	sar _ ZipArchive new.
	self changeSetFullFileNames do: [ :fileName | sar addFile: fileName as: (FileDirectory localNameFor: fileName) ].
	self textureFileNames do: [ :fileName | sar addFile: fileName as: fileName ].

	sar addString: self preambleText as: 'install/preamble'.
"	sar addString: self postscriptText as: 'install/postscript'."

	result _ StandardFileMenu newFile.
	result ifNil: [ ^nil ].
	sarName _ (result directory fullNameFor: result name).
	sar writeToFileNamed: sarName.
! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 22:07'!
preambleText
	"
	SHTDIDistro preambleText
	"

	^String streamContents: [ :stream |
		self changeSetBaseFileNames do: [ :csName |
			stream nextPutAll: 'self fileInMemberNamed: ';
				print: csName; nextPut: $.; cr ].
		self textureFileNames do: [ :txtrName |
			stream nextPutAll: 'self extractMember: ';
				print: txtrName; nextPut: $.; cr ].
	]
! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 22:01'!
textureDirectoryName
	^'Content', FileDirectory slash, 'Textures'! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 22:03'!
textureFileNames
	^self textures collect: [ :i | self textureDirectoryName, FileDirectory slash, i ]! !

!SHTDIDistro class methodsFor: 'as yet unclassified' stamp: 'daf 12/25/2004 21:58'!
textures
	" SHTDIDistro textures "
	^#('ballHog.gif' 'mallet.gif')
! !


!TCubeComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/21/2004 19:34'!
handlesPointerDown: pointer

	^ frameParent handlesPointerDown: pointer! !

!TCubeComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/21/2004 19:34'!
isComponent

	^ true! !

!TCubeComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/21/2004 19:34'!
pointerDown: pointer 
	^ frameParent pointerDown: pointer! !

!TCubeComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/21/2004 19:34'!
pointerUp: pointer
	^ frameParent pointerUp: pointer! !

!TCubeComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/21/2004 19:34'!
step
	^ frameParent step! !


!TCubeODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:40'!
moveBackForth: pointer

	| delta  |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
		delta _ selectedPoint - pointer selectedPoint.
		self meta translation: (self translation - (self orientation localPointToGlobal: delta)).
		^ true.].
	^ false.! !

!TCubeODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:41'!
moveInOut: pointer 
	"This allows you to pull an object towards you."
	| delta p0 i0 i1 t p newTranslation plainNormal |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
			"assumed just horizontal"
			plainNormal _ 0 @ 1 @ 0.
			"plainNormal _ pointer camera localToGlobal: (0@1@0)."
			p0 _ self localToGlobal: selectedPoint.
			i0 _ pointer globalPosition.
			i1 _ pointer globalTransform localPointToGlobal: 0 @ 0 @ 1.
			[t _ (p0 - i0 dot: plainNormal) / (i1 - i0 dot: plainNormal)]
				on: ZeroDivide do: [^ false].
			p _ i0 + (t abs negated * (i1 - i0)).
			delta _ p - p0.
			newTranslation _ self translation + delta.
			(pointer globalToLocal: newTranslation) z < pointer camera zScreen negated
				ifTrue: ["self moveWindow: pointer."
					^ true].
			self meta translation: newTranslation.
			^ true].
	^ false
! !

!TCubeODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 12:01'!
pointerDown: pointer 
	myPointer := pointer.
	selectedPoint := "(pointer selectedFrame translation) +" (pointer selectedPoint).
	self startStepping.
	^ true! !

!TCubeODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:40'!
pointerUp: pointer
	self stopStepping.
	myPointer _ nil.
	selectedPoint _ nil.
	^ true.! !

!TCubeODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:40'!
step
	| |
	myPointer ifNil: [^ self].
	myPointer shiftPressed
		ifFalse:[self moveBackForth: myPointer]
		ifTrue:[self moveInOut: myPointer].

	body position: self globalPosition.
	body quaternion: self quaternion! !


!TCylinderComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 20:03'!
handlesPointerDown: pointer

	^ frameParent handlesPointerDown: pointer! !

!TCylinderComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 20:07'!
isComponent

	^ true! !

!TCylinderComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 20:04'!
pointerDown: pointer 
	^ frameParent pointerDown: pointer! !

!TCylinderComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 20:03'!
pointerUp: pointer
	^ frameParent pointerUp: pointer! !

!TCylinderComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 20:03'!
step
	^ frameParent step! !


!TCylinderODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:45'!
moveBackForth: pointer

	| delta  |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
		delta _ selectedPoint - pointer selectedPoint.
		self meta translation: (self translation - (self orientation localPointToGlobal: delta)).
		^ true.].
	^ false.! !

!TCylinderODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:45'!
moveInOut: pointer 
	"This allows you to pull an object towards you."
	| delta p0 i0 i1 t p newTranslation plainNormal |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
			"assumed just horizontal"
			plainNormal _ 0 @ 1 @ 0.
			"plainNormal _ pointer camera localToGlobal: (0@1@0)."
			p0 _ self localToGlobal: selectedPoint.
			i0 _ pointer globalPosition.
			i1 _ pointer globalTransform localPointToGlobal: 0 @ 0 @ 1.
			[t _ (p0 - i0 dot: plainNormal) / (i1 - i0 dot: plainNormal)]
				on: ZeroDivide do: [^ false].
			p _ i0 + (t abs negated * (i1 - i0)).
			delta _ p - p0.
			newTranslation _ self translation + delta.
			(pointer globalToLocal: newTranslation) z < pointer camera zScreen negated
				ifTrue: ["self moveWindow: pointer."
					^ true].
			self meta translation: newTranslation.
			^ true].
	^ false
! !

!TCylinderODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 10:20'!
pointerDown: pointer 
	myPointer := pointer.
	selectedPoint := (pointer selectedFrame translation) + (pointer selectedPoint).
	self startStepping.
	^ true! !

!TCylinderODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:46'!
pointerUp: pointer
	self stopStepping.
	myPointer _ nil.
	selectedPoint _ nil.
	^ true.! !

!TCylinderODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:46'!
step
	| |
	myPointer ifNil: [^ self].
	myPointer shiftPressed
		ifFalse:[self moveBackForth: myPointer]
		ifTrue:[self moveInOut: myPointer].

	body position: self globalPosition.
	body quaternion: self quaternion! !


!TGroupODE methodsFor: 'accessing' stamp: 'daf 12/20/2004 18:58'!
body

	^body ! !

!TGroupODE methodsFor: 'accessing' stamp: 'daf 12/20/2004 18:58'!
body: aBody

	body _ aBody! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 18:58'!
handlesPointerDown: pointer

	^ true.! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 12/20/2004 18:58'!
isComponent

	^ true.! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 13:00'!
moveBackForth: pointer

	| delta  |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
		delta _ selectedPoint - pointer selectedPoint.
		self meta translation: (self translation - (self orientation localPointToGlobal: delta)).
		^ true.].
	^ false.! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:20'!
moveInOut: pointer 
	"This allows you to pull an object towards you."
	| delta p0 i0 i1 t p newTranslation plainNormal |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
			"assumed just horizontal"
			plainNormal _ 0 @ 1 @ 0.
			"plainNormal _ pointer camera localToGlobal: (0@1@0)."
			p0 _ self localToGlobal: selectedPoint.
			i0 _ pointer globalPosition.
			i1 _ pointer globalTransform localPointToGlobal: 0 @ 0 @ 1.
			[t _ (p0 - i0 dot: plainNormal) / (i1 - i0 dot: plainNormal)]
				on: ZeroDivide do: [^ false].
			p _ i0 + (t abs negated * (i1 - i0)).
			delta _ p - p0.
			newTranslation _ self translation + delta.
			(pointer globalToLocal: newTranslation) z < pointer camera zScreen negated
				ifTrue: ["self moveWindow: pointer."
					^ true].
			self meta translation: newTranslation.
			^ true].
	^ false
! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 09:00'!
pick: pointer

	^true.! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 10:19'!
pointerDown: pointer 
	myPointer := pointer.
	selectedPoint := (pointer selectedFrame translation) + (pointer selectedPoint).
	self startStepping.
	^ true! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:05'!
pointerUp: pointer
	self stopStepping.
	myPointer _ nil.
	selectedPoint _ nil.
	^ true.! !

!TGroupODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 08:37'!
step
	| |
	myPointer ifNil: [^ self].
	myPointer shiftPressed
		ifFalse:[self moveBackForth: myPointer]
		ifTrue:[self moveInOut: myPointer].

	body position: self globalPosition.
	body quaternion: self quaternion! !


!TMesh methodsFor: '*Croquet-Croquet' stamp: 'daf 12/26/2004 14:30'!
faceGroups
	^faceGroups! !

!TMesh methodsFor: '*Croquet-Croquet' stamp: 'daf 12/26/2004 15:32'!
textureUV
	^textureUV! !


!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/26/2004 15:32'!
fromTMesh: aTMesh
	| mesh |
	mesh := TMeshComponent meta new.
	mesh meta initializeWithVertices: aTMesh vertices 
		alias: nil 
		norms: aTMesh normals
		textureUV: aTMesh textureUV
		faceGroups: aTMesh faceGroups
		material: aTMesh material.
	mesh meta initBounds.
	^ mesh
! !

!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/24/2004 09:59'!
handlesPointerDown: pointer

	^ frameParent handlesPointerDown: pointer! !

!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/24/2004 09:59'!
isComponent

	^ true! !

!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/24/2004 09:59'!
pointerDown: pointer 
	^ frameParent pointerDown: pointer! !

!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/24/2004 09:59'!
pointerUp: pointer
	^ frameParent pointerUp: pointer! !

!TMeshComponent methodsFor: 'as yet unclassified' stamp: 'daf 12/24/2004 09:59'!
step
	^ frameParent step! !


!TMeshODE methodsFor: 'accessing' stamp: 'daf 12/26/2004 15:34'!
body


	^body! !

!TMeshODE methodsFor: 'accessing' stamp: 'daf 12/26/2004 15:34'!
body: aBody


	body _ aBody! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 12/26/2004 15:36'!
fromTMesh: aTMesh
	| mesh |
	mesh := TMeshODE meta new.
	mesh meta initializeWithVertices: aTMesh vertices 
		alias: nil 
		norms: aTMesh normals
		textureUV: aTMesh textureUV
		faceGroups: aTMesh faceGroups
		material: aTMesh material.
	mesh meta initBounds.
	^ mesh
! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 12/26/2004 15:34'!
handlesPointerDown: pointer

	^ true.! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 12/26/2004 15:34'!
isComponent

	^ true.! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:47'!
moveBackForth: pointer

	| delta  |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
		delta _ selectedPoint - pointer selectedPoint.
		self meta translation: (self translation - (self orientation localPointToGlobal: delta)).
		^ true.].
	^ false.! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:48'!
moveInOut: pointer 
	"This allows you to pull an object towards you."
	| delta p0 i0 i1 t p newTranslation plainNormal |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
			"assumed just horizontal"
			plainNormal _ 0 @ 1 @ 0.
			"plainNormal _ pointer camera localToGlobal: (0@1@0)."
			p0 _ self localToGlobal: selectedPoint.
			i0 _ pointer globalPosition.
			i1 _ pointer globalTransform localPointToGlobal: 0 @ 0 @ 1.
			[t _ (p0 - i0 dot: plainNormal) / (i1 - i0 dot: plainNormal)]
				on: ZeroDivide do: [^ false].
			p _ i0 + (t abs negated * (i1 - i0)).
			delta _ p - p0.
			newTranslation _ self translation + delta.
			(pointer globalToLocal: newTranslation) z < pointer camera zScreen negated
				ifTrue: ["self moveWindow: pointer."
					^ true].
			self meta translation: newTranslation.
			^ true].
	^ false
! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 12/26/2004 15:34'!
pick: pointer

	^true.! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 12:01'!
pointerDown: pointer 
	myPointer := pointer.
	selectedPoint := "(pointer selectedFrame translation) +" (pointer selectedPoint).
	self startStepping.
	^ true! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:48'!
pointerUp: pointer
	self stopStepping.
	myPointer _ nil.
	selectedPoint _ nil.
	^ true.! !

!TMeshODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:49'!
step
	| |
	myPointer ifNil: [^ self].
	myPointer shiftPressed
		ifFalse:[self moveBackForth: myPointer]
		ifTrue:[self moveInOut: myPointer].

	body position: self globalPosition.
	body quaternion: self quaternion! !


!TSphereODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:50'!
moveBackForth: pointer

	| delta  |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
		delta _ selectedPoint - pointer selectedPoint.
		self meta translation: (self translation - (self orientation localPointToGlobal: delta)).
		^ true.].
	^ false.! !

!TSphereODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:50'!
moveInOut: pointer 
	"This allows you to pull an object towards you."
	| delta p0 i0 i1 t p newTranslation plainNormal |
	(pointer frame: self pickPlane: selectedPoint normal: 
		(self inverseGlobalOrientation localPointToGlobal: 
		pointer selectedCameraTransform lookAt negated)) ifTrue:[
			"assumed just horizontal"
			plainNormal _ 0 @ 1 @ 0.
			"plainNormal _ pointer camera localToGlobal: (0@1@0)."
			p0 _ self localToGlobal: selectedPoint.
			i0 _ pointer globalPosition.
			i1 _ pointer globalTransform localPointToGlobal: 0 @ 0 @ 1.
			[t _ (p0 - i0 dot: plainNormal) / (i1 - i0 dot: plainNormal)]
				on: ZeroDivide do: [^ false].
			p _ i0 + (t abs negated * (i1 - i0)).
			delta _ p - p0.
			newTranslation _ self translation + delta.
			(pointer globalToLocal: newTranslation) z < pointer camera zScreen negated
				ifTrue: ["self moveWindow: pointer."
					^ true].
			self meta translation: newTranslation.
			^ true].
	^ false
! !

!TSphereODE methodsFor: 'as yet unclassified' stamp: 'daf 1/9/2005 11:58'!
pointerDown: pointer 
	myPointer := pointer.
	selectedPoint := "(pointer selectedFrame translation) +" (pointer selectedPoint).
	self startStepping.
	^ true! !

!TSphereODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:51'!
pointerUp: pointer
	self stopStepping.
	myPointer _ nil.
	selectedPoint _ nil.
	^ true.! !

!TSphereODE methodsFor: 'as yet unclassified' stamp: 'daf 1/8/2005 12:51'!
step
	| |
	myPointer ifNil: [^ self].
	myPointer shiftPressed
		ifFalse:[self moveBackForth: myPointer]
		ifTrue:[self moveInOut: myPointer].

	body position: self globalPosition.
	body quaternion: self quaternion! !

TSphere subclass: #TSphereODE
	instanceVariableNames: 'body myPointer selectedPoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
TCylinder subclass: #TCylinderODE
	instanceVariableNames: 'body myPointer selectedPoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
TCube subclass: #TCubeODE
	instanceVariableNames: 'body myPointer selectedPoint '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'ODE-Croquet'!
