'From Jasmine-rc1 of 7 October 2004 [latest update: #200] on 13 January 2005 at 7:47:39 pm'!
"Change Set:		ShadowForJasmine
Date:			13 January 2005
Author:			Takashi Yamamiya

for Jasmine #200.
It is just show figure of shadow withoug stencil.
"!

B3DHardwareEngine subclass: #OpenGL
	instanceVariableNames: 'glExt extensions frontFace currentPortal maxPortalDepth changeTexture test timeStamp textureManager fontManager glListRegistry instance isMirror inPortal3D openDisplayList camera forceWire numVtx numPrims stencil '
	classVariableNames: 'InstalledOpenGLLibrary '
	poolDictionaries: 'OpenGLConstants GLExtConstants '
	category: 'Croquet-OpenGL'!
TCube subclass: #TFloor
	instanceVariableNames: 'shadowRay '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Objects'!

!TFloor commentStamp: '<historical>' prior: 0!
This is a floor with shadow.

Structure:
 shadowRay		TRay -- The ray is for find shadowed object. It looks from the shadow to light.
!

Object subclass: #TStencil
	instanceVariableNames: 'ogl depth '
	classVariableNames: ''
	poolDictionaries: 'OpenGLConstants '
	category: 'Croquet-OpenGL'!

!TStencil commentStamp: '<historical>' prior: 0!
Stencil wrapper.

It regards the stencil buffer as a number of stencil layers.
You can just render in hole of the stencils.
!

TeapotMorph subclass: #ShadowDemoMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Croquet-Morphic'!

!B3DMatrix4x4 methodsFor: 'accessing' stamp: 'tak 6/13/2004 22:57'!
direction: v 
	"v is a normalized vector for direction"
	| side up |
	up _ v y abs = 1.0
				ifTrue: [0 @ 0 @ -1]
				ifFalse: [0 @ 1 @ 0].
	side _ (up cross: v) normalized.
	up _ (v cross: side) normalized.
	self a11: side x.
	self a21: side y.
	self a31: side z.
	self a12: up x.
	self a22: up y.
	self a32: up z.
	self a13: v x.
	self a23: v y.
	self a33: v z! !


!OpenGL methodsFor: 'accessing' stamp: 'tak 5/31/2004 23:56'!
stencil
	^ stencil ifNil: [stencil _ TStencil newFor: self].! !


!TFrame methodsFor: 'testing' stamp: 'tak 6/1/2004 23:00'!
hasShadow
	^ false! !

!TFrame methodsFor: 'render' stamp: 'tak 6/1/2004 22:02'!
renderShadow: ogl
	self render: ogl! !


!TPrimitive methodsFor: 'render' stamp: 'tak 6/1/2004 23:16'!
renderShadow: ogl
	self renderPrimitiveCached: ogl.
! !

!TPrimitive methodsFor: 'testing' stamp: 'tak 6/1/2004 23:18'!
hasShadow
	^ true! !


!TFloor methodsFor: 'accessing' stamp: 'tak 5/28/2004 16:51'!
light
	^ self root lightFrames first 
! !

!TFloor methodsFor: 'accessing' stamp: 'tak 6/14/2004 01:19'!
plane
	"shadow plane (a @ b @ c @ d) where ax + by + cz + d = 0"
	| norm point w |
	norm _ normals at: 5.
	norm _ self globalTransform localDirToGlobal: 0 @ 1 @ 0.
	point _ self globalTransform localPointToGlobal: 0 @ (extent y / 2) @ 0.
	w _ (norm dot: point) negated.
	^ B3DVector4 x: norm x y: norm y z: norm z w: w! !

!TFloor methodsFor: 'accessing' stamp: 'tak 5/29/2004 18:38'!
shadowMatrixLight: light plane: plane
"
http://cgi3.tky.3web.ne.jp/~tkano/columns/20000716.shtml
M = pLI - Lp 
"
	| m i |
	m _ B3DMatrix4x4 new.
	m at: 1 at: 1 put: light x * plane x.
	m at: 2 at: 1 put: light x * plane y.
	m at: 3 at: 1 put: light x * plane z.
	m at: 4 at: 1 put: light x * plane w.

	m at: 1 at: 2 put: light y * plane x.
	m at: 2 at: 2 put: light y * plane y.
	m at: 3 at: 2 put: light y * plane z.
	m at: 4 at: 2 put: light y * plane w.

	m at: 1 at: 3 put: light z * plane x.
	m at: 2 at: 3 put: light z * plane y.
	m at: 3 at: 3 put: light z * plane z.
	m at: 4 at: 3 put: light z * plane w.

	m at: 1 at: 4 put: light w * plane x.
	m at: 2 at: 4 put: light w * plane y.
	m at: 3 at: 4 put: light w * plane z.
	m at: 4 at: 4 put: light w * plane w.

	i _ B3DMatrix4x4 identity.
	m _ (plane dot: light) * i - m.
	^m
! !

!TFloor methodsFor: 'accessing' stamp: 'tak 6/13/2004 13:58'!
shadowingFrames
	^ self root frameChildren
		select: [:e | e hasShadow]! !

!TFloor methodsFor: 'events' stamp: 'tak 6/14/2004 01:14'!
handlesPointerDown: pointer
	^ true.! !

!TFloor methodsFor: 'events' stamp: 'tak 6/14/2004 12:04'!
pointerDown: pointer 
	self trackShadowRay: pointer.
! !

!TFloor methodsFor: 'events' stamp: 'tak 6/14/2004 12:02'!
pointerMove: pointer 
	| delta target |
	shadowRay selectedFrame ifNil: [^ false].
	delta _  pointer selectedPoint - shadowRay translation.
	target _ shadowRay selectedFrame objectOwner.
	target = self ifFalse: [
	target translation: target translation + delta].
	self trackShadowRay: pointer.
! !

!TFloor methodsFor: 'events' stamp: 'tak 6/14/2004 11:57'!
trackShadowRay: pointer
	shadowRay translation: pointer selectedPoint.
	shadowRay
		localTransform: (shadowRay localTransform direction: (self light globalPosition - shadowRay globalPosition) negated normalized).
! !

!TFloor methodsFor: 'testing' stamp: 'tak 6/1/2004 21:40'!
hasShadow
	^ false! !

!TFloor methodsFor: 'testing' stamp: 'tak 1/13/2005 17:26'!
isComponent
	"not implemented yet"
	"^ true"
	^ super isComponent! !

!TFloor methodsFor: 'render' stamp: 'tak 1/13/2005 18:22'!
renderFrame: ogl parent: parent root: root 
	| result |
	result _ super
				renderFrame: ogl
				parent: parent
				root: root.
	ogl stencil push.
	ogl stencil
		cutWhile: [self renderShadows: ogl].
	ogl stencil
		renderWhile: [self renderShadowedFloor: ogl].
	ogl stencil pop.

	^ result! !

!TFloor methodsFor: 'render' stamp: 'tak 6/1/2004 23:08'!
renderShadowedFloor: ogl

	| dx dy dz |
	dx _ extent x / 2.0.
	dy _ extent y / 2.0.
	dz _ extent z / 2.0.
	ogl glPushMatrix.

	ogl glMultMatrixf: self globalTransform transposed.
	ogl glPolygonOffset: -1.0 with: -20.0.
	ogl glEnable: GLPolygonOffsetFill.
	ogl glEnable: GLBlend.
	ogl glBlendFunc: GLSrcAlpha with: GLOneMinusSrcAlpha.
	ogl glDisable: GLLighting.
	ogl glColor4f: 0.0 with:0.0 with: 0.0 with: 0.5.

	ogl glBegin: GLQuads.
	ogl glVertex3f: dx negated with: dy with: dz negated.
	ogl glVertex3f: dx negated with: dy with:dz.
	ogl glVertex3f: dx with: dy with: dz.
	ogl glVertex3f: dx with: dy with: dz negated.
	ogl glEnd.

	ogl glEnable: GLLighting.
	ogl glDisable: GLBlend.
	ogl glDisable: GLPolygonOffsetFill.

	ogl glPopMatrix.
! !

!TFloor methodsFor: 'render' stamp: 'tak 1/13/2005 18:58'!
renderShadows: ogl 
	| light |
	light _ self light globalPosition asB3DVector4.
	ogl glColorMask: GLFalse with: GLFalse with: GLFalse with: GLFalse.
	ogl glDepthMask: GLFalse.
	ogl glDisable: GLDepthTest.
	ogl glPushMatrix.
	ogl glMultMatrixf: (self shadowMatrixLight: light plane: self plane).
	self renderTargets: ogl.
	ogl glPopMatrix.
	ogl glEnable: GLDepthTest.
	ogl glColorMask: GLTrue with: GLTrue with: GLTrue with: GLTrue.
	ogl glDepthMask: GLTrue.
! !

!TFloor methodsFor: 'render' stamp: 'tak 6/13/2004 13:58'!
renderTargets: ogl 
	self shadowingFrames
		do: [:e | 
			ogl glPushMatrix.
			ogl glMultMatrixf: e globalTransform transposed.
			e renderShadow: ogl.
			ogl glPopMatrix]! !

!TFloor methodsFor: 'initialize' stamp: 'tak 6/14/2004 10:15'!
initialize
	super initialize.
	shadowRay _ TRay new.
	shadowRay minDistance: 1.0.
	self addChild: shadowRay.! !


!TPortal methodsFor: 'render' stamp: 'tak 1/13/2005 18:56'!
render: ogl depth: depth
	| trans m2 toSpace gt containerPortal portalClip color clipPlanes renderedObjects ac saveSelected saveDoSelect saveMinDistance portalDistance saveForceWire top portalPoint stencil |

" This method is the recursive portal renderer. enter refers to the renderer entering the portal. If you want the camera entering check out TPortal>>testEnter: ac."
	renderedObjects _ 1. "We are also rendering the portal."
" ------- We keep track of which portal we are currently working in to avoid a tight recursion error,where the portal re-enters itself to render. It is (somewhat) OK to re-enter from another portal. This is equivalent to a mirror in a mirror situation. Here we need to keep a count of the re-entries.------"
	toSpace _ toPortal root.
	toSpace = toPortal ifTrue:[ top _ self. toSpace _ self root. ] "The portal is not installed on the other side!!"
		ifFalse:[top _ toPortal].
	containerPortal _ ogl currentPortal.
	ogl currentPortal: self.
" ------ For rendering the portal ONLY - we turn off depth testing. We just want to write into the stencil buffer here and set the color of the toSpace. Depth testing is turned back on before we recurse into the connected portal.------"
	gt _ self globalTransform. 

	ogl glPushMatrix. 
	ogl glMultMatrixf: gt transposed.
	ogl glDisable: GLDepthTest. 

" ------ Paint the portal with the color of the TSpace ------ "
	ogl glDisable: GLLighting.
	color _ B3DVector3 x: toSpace color red y: toSpace color green z: toSpace color blue.

	ogl glColor3fv: color.

	stencil _ ogl stencil.
	stencil push.

" ------ Render the stencil here. ------ "
	stencil cutWhile: [
	saveForceWire _ ogl forceWire.
	ogl forceWire:false.
	self renderPortal: ogl.
	ogl forceWire: saveForceWire.
	].

	ogl glEnable: GLDepthTest.
	ogl glEnable: GLLighting.
	ogl glPopMatrix.

	ogl glPushMatrix.

"	m1 _ self globalTransform."
	top isPortal ifTrue:[m2 _ top globalMatrixOut.] ifFalse:[m2 _ top globalTransform.].
" ------- For simplicity - and because I can't think of a good reason not to do this - if a portal points back to itself, it is considered to be a mirror. Note that we flip the directions of the polyon tests as well. This is restored at the end. We are inverting the x-coordinate of the matrix here. ------" 
	self = top ifTrue:[
		m2 a11: m2 a11 negated.
		m2 a21: m2 a21 negated.
		m2 a31: m2 a31 negated.
		ogl flipFace.].

	ac _ ogl camera.
	portalClip _ac portalClip.
	ac portalClip: m2.

" ------ This math is simply: 

			m1 = trans*m2
			m1 * m2**-1 = trans * m2 * m2**-1
			m1 * m2**-1 = trans. 

 We then replace the transform matrix of the TCamera with the appropriate transform, which places the TCamera into the correct position in the new space.------"
	clipPlanes _ ac clipPlanes.
	ac clipPlanes: (self initClipPlanes: ac globalTransform mirror: ogl isMirror).
self = top ifTrue:[ ogl mirrorFlip.].
	trans _ m2 composeWith: gt orthoNormInverse.
	ac globalTransform:
		(trans composeWith: ac globalTransform).
	ac pointer ifNotNil:[
		saveSelected _ ac pointer copiedSelection.
		saveMinDistance _ ac pointer minDistance.
		saveDoSelect _ ac pointer doSelect.
		
		(ac pointer pointerPick: self boundSphere) ifTrue:[
				portalDistance _ ac pointer selectedDistance.
				ac pointer minDistance: portalDistance.
				portalPoint _ ac pointer selectedPoint.
				ac pointer selected: saveSelected. "restore the current selections"
				ac pointer selectedPortal: self point: portalPoint. "if we picked a portal"
			] ifFalse:[ 
				ac pointer isDown ifTrue:[
					ac pointer selectedPortal = self ifTrue:[
						(ac pointer frame: self pickPlane: (B3DVector3 new) normal: outVector)
						 ifTrue:[ 
							portalPoint _ ac pointer selectedPoint.
							ac pointer selected: saveSelected.
							ac pointer selectedPortalPoint: portalPoint.
						].
					].
				].
				portalDistance _ Float infinity.
				ac pointer doSelect: false.
				ac pointer selected: saveSelected.
			].
		ac pointer globalTransform: 
			(ac globalTransform composeWith: ac pointer localTransform).
		].
	stencil renderWhile: [
	renderedObjects _ renderedObjects + (toSpace renderSpace: ogl port: top depth: depth+1 ghostFrame: nil). "<------ Render TSpace here!! -------"
	].
	ac clipPlanes: clipPlanes.
	self = top ifTrue:[ogl flipFace. ogl mirrorFlip.].
	ogl glPopMatrix.
" ------ Just in case we jumped into a portal, restore the stencil depth ------"
	stencil renderRestoreWhile: [

"------ Render the front face invisibly to set the z-buffer to ensure nothing bleeds into the portal space from our space. ------"			
	ogl glPushMatrix.

	ogl glPolygonOffset: 2.1 with: 4.0.
	ogl glEnable: GLPolygonOffsetFill.
	ogl glColorMask: 0 with: 0 with: 0 with: 0.
	ogl glMultMatrixf: gt transposed.
	ogl forceWire: false.
	self renderPortal: ogl.
	ogl forceWire: saveForceWire.
	ogl glColorMask:GLTrue with: GLTrue with:GLTrue with:GLTrue.
	ogl glDisable: GLPolygonOffsetFill.
	ogl glPopMatrix.
	].

	depth = 1 ifTrue:[ogl glDisable: GLStencilTest.].
	ogl currentPortal: containerPortal.
	ac portalClip: portalClip.
	ac pointer ifNotNil:[
		ac pointer doSelect: saveDoSelect.
		ac pointer minDistance: saveMinDistance.
		ac pointer maxDistance: (ac pointer maxDistance min: portalDistance).
		].
	stencil pop.
	^ renderedObjects.
! !


!TSpace methodsFor: 'accessing' stamp: 'tak 5/28/2004 16:50'!
lightFrames
	^ lightFrames! !


!TStencil methodsFor: 'render' stamp: 'tak 6/1/2004 17:42'!
cutWhile: aBlock
	depth < 1 ifTrue: [^self].
	ogl glStencilFunc:GLEqual with: depth - 1 with: -1.
	ogl glStencilOp:GLKeep with:GLKeep with:GLIncr.
  	aBlock value.
! !

!TStencil methodsFor: 'render' stamp: 'tak 5/31/2004 21:33'!
renderRestoreWhile: aBlock
	depth < 1 ifTrue: [^self].
	ogl glStencilFunc: GLLequal with: depth-1 with: -1.
	ogl glStencilOp: GLKeep with: GLKeep with: GLKeep.
	aBlock value.
! !

!TStencil methodsFor: 'render' stamp: 'tak 6/1/2004 17:41'!
renderWhile: aBlock
	depth < 1 ifTrue: [^self].
	ogl glStencilFunc: GLEqual with: depth with: -1.
	ogl glStencilOp: GLKeep with: GLKeep with: GLKeep.
	aBlock value.
! !

!TStencil methodsFor: 'accessing' stamp: 'tak 6/1/2004 17:43'!
pop
	depth _ depth - 1.
	depth = 0
		ifTrue: [ogl glDisable: GLStencilTest.
			"ogl glClear: GLStencilBufferBit"].
	ogl glStencilFunc: GLEqual with: depth with: -1.
	ogl glStencilOp: GLKeep with: GLKeep with: GLKeep! !

!TStencil methodsFor: 'accessing' stamp: 'tak 6/1/2004 17:43'!
push
	depth _ depth + 1.
	depth = 1 ifTrue: [ogl glEnable: GLStencilTest. "ogl glClear: GLStencilBufferBit"].
! !

!TStencil methodsFor: 'initialize' stamp: 'tak 6/1/2004 01:33'!
initialize: anOGL
	ogl _ anOGL.
	depth _ 0.
	ogl glClear: GLStencilBufferBit.
! !


!TStencil class methodsFor: 'instance creation' stamp: 'tak 5/31/2004 22:08'!
newFor: ogl 
	^ super new initialize: ogl! !


!TWindow methodsFor: 'testing' stamp: 'tak 6/1/2004 23:01'!
hasShadow
	^ true! !

!TWindow methodsFor: 'render' stamp: 'tak 6/1/2004 23:16'!
renderShadow: ogl
	windowFrame renderAlpha: ogl.
	rectBack renderShadow: ogl.
	rectFront renderShadow: ogl.! !


!TeapotMorph methodsFor: 'toys' stamp: 'tak 1/13/2005 18:28'!
makeLight: sp
	| light tframe |
	light _ TLight new.
	tframe _ TSpinner new.
	tframe translation: -40@100@40.
	tframe rotationAroundZ: 120.
	"This is to avoid some odd lighting effects"
	tframe rotateBy: 1 around: 1@0@0.
	tframe matNil.
	tframe contents: light.
	sp addChild: tframe.! !

!TeapotMorph methodsFor: 'toys' stamp: 'tak 1/13/2005 16:49'!
makeShadowedFloor: sp fileName: txtrName
	| stone txt |

	txt _ TTexture
				new initializeWithFileName: txtrName
				mipmap: true
				shrinkFit: false.
	txt uvScale: 8.0@8.0.

	stone _ TFloor new.
	stone extentX:80 y:0.5 z: 80.
	stone translationX: 0 y: -4.0 z: 0.0.
	stone texture: txt.
	stone objectName: 'floor'.
	sp addChild: stone.
	^ stone.

! !


!ShadowDemoMorph methodsFor: 'initialize' stamp: 'tak 1/13/2005 19:21'!
initializeDefaultSpace
	"Create a new space"
	| space tframe cube |
	space _ TSpace new.
	self makeLight: space.
	self makeShadowedFloor: space fileName: 'lawn.BMP'.
	tframe _ TSkyBox new initializeWithFileName: 'JUL'.
	space addChild: tframe.
	self makeMirror: space.
	self makeUnderwater3: space.
	cube _ TCube new.
	space addChild: cube.
	cube translation: 0@0@5.

	^ space! !


!ShadowDemoMorph class methodsFor: 'parts bin' stamp: 'tak 1/13/2005 17:08'!
descriptionForPartsBin
	^ super descriptionForPartsBin! !

TStencil removeSelector: #ogl:!
